#include "Document.hpp"
#include <iostream>
#include <string>
#include <fstream>
#include <chrono>

using namespace std;

std::string loadFileToString(const std::string &filename){
	std::ifstream t(filename);
	t.seekg(0, std::ios::end);
	size_t size = t.tellg();
	std::string buffer(size, ' ');
	t.seekg(0);
	t.read(&buffer[0], size); 
	return buffer;
}

int main() {
	string html = loadFileToString("./html/coinmarketcapAll.html");

	std::string &someHtmlString = html;
	std::string someSelectorString = "div";
	auto testDocument = gq::Document::Create();
	auto start= chrono::system_clock::now();
	testDocument->Parse(someHtmlString);
	auto startcss= chrono::system_clock::now();

	try
	{
		auto results = testDocument->Find(someSelectorString);
		const auto numResults = results.GetNodeCount();
		cout<<"numResults: "<<numResults<<endl;
	}
	catch(std::runtime_error& e)
	{
		throw e;
		// Necessary because naturally, the parser can throw.
	}


	auto end= chrono::system_clock::now();
	cout<<"Time Parse : "<<chrono::duration_cast<chrono::microseconds>(startcss-start).count()<< " microseconds."<<endl;
	cout<<"Time CSS   : "<<chrono::duration_cast<chrono::microseconds>(end-startcss).count()<< " microseconds."<<endl;

	return 0;
}

